// init some vars
var response = "";
var convoID = "";
var bubbleNumber = 1;
var bubbleWidth = 0;
var bubbleMaxWidth = ($(window).width())-60;
var bubbleDefaultHeight = 40;
var initialDivHeight = 0;
var toastShown = false;
var bannerID = 'ca-app-pub-0960196527512350/3143953933';
var interstitialID = 'ca-app-pub-0960196527512350/4620687131';
var responseNumber = 0;		// for displaying interstitials

var admobid = {};
if( /(android)/i.test(navigator.userAgent) ) { 
    admobid = { // for Android
        banner: 'ca-app-pub-0960196527512350/4131492733',
        interstitial: 'ca-app-pub-0960196527512350/5608225934'
    };
};

document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady()
{
	// init google analytics and sent event
    analytics.startTrackerWithId('UA-54283593-35');
    analytics.trackView('Main');
    analytics.debugMode();
    
    // display admob banner
    /*if( window.plugins && window.plugins.AdMob ) {
        var am = window.plugins.AdMob;

        am.createBannerView( 
            {
            'publisherId': bannerID,
            'adSize': am.AD_SIZE.SMART_BANNER,
            'bannerAtTop': false,
            'overlap': false
            }, 
            function() {
                am.requestAd(
                    { 'isTesting':false }, 
                    function(){
                        am.showAd( true );
                    }, 
                    function(){ console.log('failed to request ad'); }
                );
            }, 
            function(){ console.log('failed to create banner view'); }
        );
    } else {
    	console.log('AdMob plugin not available/ready.');
    }*/
    
    if (AdMob) {
        AdMob.createBanner({
            adId : admobid.banner,
            adSize: 'SMART_BANNER',
            position : AdMob.AD_POSITION.BOTTOM_CENTER,
            autoShow : true,
            overlap: true,
            isTesting: false
        });
    }
}

function displayInterstitial()
{
    /*if( window.plugins && window.plugins.AdMob ) {
        var am = window.plugins.AdMob;
        am.createInterstitialView(
        		{
        			'publisherId': interstitialID,
        		},
        		function() {
        			am.requestInterstitialAd( { 'isTesting':false }, function() {}, function() { console.log('failed to request ad'); });
        		},
        		function() {
        			console.log("Interstitial failed");
        		}
        )
    }
    else
    {
    	console.log("AdMob plugin not available/ready");
    }*/
	
	AdMob.prepareInterstitial({
	    adId: admobid.interstitial,
	    autoShow: true
	});
	
	/*AdMob.isInterstitialReady(function(isready){
	    if(isready) AdMob.showInterstitial();
	});*/
};

function ScaleContentToDevice()
{
	   scroll(0, 0);
	   var headerHeight = 0; //$("#jqmHeader:visible").outerHeight();
	   var footerHeight = $("#footer:visible").outerHeight();
	   var viewportHeight = $(window).height();

	   var content = $("#response:visible");
	   var contentMargins =  content.outerHeight() - content.height();

	   var contentheight = viewportHeight - headerHeight - footerHeight - contentMargins;

	   content.height(contentheight);
	   //alert("fsfds");
}

//a toast message
var toast = function(msg){
	$("<div class='ui-loader ui-overlay-shadow ui-body-e ui-corner-all'><h3>"+msg+"</h3></div>")
	.css({ display: "block", 
		opacity: 0.90, 
		position: "fixed",
		padding: "7px",
		"text-align": "center",
		"background-color": "black",
		width: "270px",
		left: ($(window).width() - 284)/2,
		top: $(window).height()/2 })
	.appendTo( $.mobile.pageContainer ).delay( 2000 )
	.fadeOut( 400, function(){
		$(this).remove();
	});
}

var loader = function(action) {
	if (action=="load")
	{
		$("<div id='loader' class='ui-loader'><img src=css/images/ajax-loader.gif /></div>")
		.css({ display: "none", 
			opacity: 0.90, 
			position: "fixed",
			padding: "7px",
			"text-align": "center",
			width: "270px",
			left: ($(window).width() - 284)/2,
			top: $(window).height()/2 })
			.appendTo( $.mobile.pageContainer )
	}
	if (action=="show")
	{
		$('#loader').css({display: "block"});
	}
	if (action=="hide")
	{
		$('#loader').css({display: "none"});
	}
}

var playRandomSound = function()
{
	var randomSoundNumber = Math.round(Math.random()*47) + 1;
	
    var src = "/android_asset/www/snd/snd"+randomSoundNumber+".mp3"
    var my_media = new Media(src,
    // success callback
    function () { console.log("playAudio():Audio Success"); },
    // error callback
    function (err) { console.log("playAudio():Audio Error: " + err); }
    );

    // Play audio
    my_media.play();
    
    console.log("playing random sound number "+randomSoundNumber);
}

// returns random string with clicking send
var getRandomString = function()
{
	var randomE = Math.round(Math.random()*20) + 1;
	var randomO = Math.round(Math.random()*20) + 1;
	
	var randomString = "g";
	
	for (i=0; i<randomE; i++)
	{
		randomString = randomString + "r";
	}
	
	for (i=0; i<randomO; i++)
	{
		randomString = randomString + "r";
	}
	
	randomString = randomString + "r";
	
	return randomString;
}

$(document).on('pagebeforeshow', '#main', function()
{
	$.support.cors = true;
    $.mobile.allowCrossDomainPages = true;
    
    loader("load");
	
	console.log('jquery mobile loading');
	//ScaleContentToDevice();
	
    // show toast message at startup
    if (!toastShown) {
    	toast("Swipe screen for info.");
    	toastShown = true;
    };
    
    // set height of response div according to screen size (resize screen when virtual keyboard appears so text input isn't hidden by keyboard)
    initialDivHeight = parseInt($(window).height()-240);	// was 160
    
    $("#response").height(initialDivHeight);

    // have "say something" stay on the screen after input
    response = $("#response").html();

    // prevent page scrolling
    //$(document).delegate('ui-page', 'touchmove', false);
    
    // display info page when swiping
    $(window).swipeleft(function() {
    	$.mobile.changePage("#info", {transition: "flip", reverse: false});
    });
    
    $(window).swiperight(function() {
    	$.mobile.changePage("#info", {transition: "flip", reverse: true});
    });
    
    $("#infoHomeButton").click(function(){
    	$("#response").scrollTop($("#response")[0].scrollHeight);
    	
    	$.mobile.changePage("#main", {transition: "flow", reverse: false});
    });
});

//raise the text input by a third of the screen height
$(document).on('click', '#txtQuestion', function() {
	var newHeight = parseInt($(window).height()/2);
	newHeight = parseInt(initialDivHeight - newHeight);
	$("#response").height(newHeight);
	$("#response").scrollTop($("#response")[0].scrollHeight);
	$('#txtQuestion').focus();
});

$(document).on('click', '#btnSend', function() {
	// return response div to original height because virtual keyboard isn't being displayed
	$("#response").height(initialDivHeight);
	
	// get the input
	var question = $("#txtQuestion").val();
	
	// don't run if there's no question and the send button is clicked
	if (question=='') {
		return false;
	}
	
	loader("show");
	
	// create response html
	response += '<div class="right-chat-bubble" id="bubble-'+bubbleNumber+'">';
	response += '<div class="right-chat-bubble-glare" id="bubble-glare-'+bubbleNumber+'"></div>';
	response += '<p><span>'+question+'</span></p>';
	response += '<div class="right-chat-bubble-arrow-border"></div><div class="right-chat-bubble-arrow"></div></div>';
		
	$('#txtQuestion').val('');
	$("#response").html(response);
	
	// set the variable to the new html
	response = $("#response").html();
	
	// scroll to the bottom of text to show last inputted text
	$("#response").scrollTop($("#response")[0].scrollHeight);
	
	// increase the counter
	bubbleNumber = bubbleNumber + 1;

	// encode for sending to server as get variable
	question = encodeURI(question);
	
	// check if to display interstitial
	if (responseNumber>=10)
	{
		displayInterstitial();
		responseNumber = 0;
	}
	responseNumber = responseNumber + 1;
	
	// play a random sound
	playRandomSound();
	
	// get a random string to display
	textResponse = getRandomString();
	
	console.log("response: " + responseNumber + " - " + textResponse);
	
	response += '<div class="left-chat-bubble-container">';
	response += '<div class="left-chat-bubble-icon"><img class="left-chat-bubble-icon-image" src="css/images/icon-message.png" /></div>';
    response += '<div style="clear:none;" class="left-chat-bubble" id="bubble-'+bubbleNumber+'">';
    response += '<div class="left-chat-bubble-glare" id="bubble-glare-'+bubbleNumber+'"></div>';
    response += '<p><span>'+textResponse+'</span></p>';
    response += '<div class="left-chat-bubble-arrow-border"></div><div class="left-chat-bubble-arrow"></div></div></div>';
    $("#response").html(response);

    // set the variable to the new html
    response = $("#response").html();
     		
    $("#response").scrollTop($("#response")[0].scrollHeight);
     	   
    // increase the counter
    bubbleNumber = bubbleNumber + 1;
     	    
    loader("hide");
});